///////////////////////////////////////
// GLOBAL VARS
///////////////////////////////////////

var anyEventData = new Array();
var reminderData = new Array();
var reminderToDisplay = new Array();
var generalData=new Array();
var currentHolidays=new Array();
var userData=new Array();
var bFirstRunComplete=false;
var currentOffset;

var numberOfPromos = 0;
var currentPromo = 0;

var currentReminder = 0;

var GENERAL_DATA_DIR = "Resources/xml/";
var GENERAL_DATA_XML = loc("general.xml");
var GENERAL_DATA_BACKUP_XML = loc("general_backup.xml");
var USER_DATA_XML = "user.xml";
var USER_DATA_BACKUP_XML = "user_backup.xml";

var DIRECTORY_DIV = "\\";

var GEN_HOLIDAY_PERIOD = 7;
var GEN_HOLIDAY_REMIND_TIME = "12:01 AM";

var REMIND_MINUTES = 1000 * 60;
var REMIND_HOURS = 1000 * 60 * 60;
var REMIND_DAYS = 1000 * 60 * 60 * 24;

var GENERAL_LINE1_COLOR = "#FFFFFF";
var USER_LINE1_COLOR = "#d7d7d7";

///////////////////////////////////////
// Scrolling related constants
///////////////////////////////////////
var TOP_SCROLLER_POSITION = 91;
var BOTTOM_SCROLLER_POSITION = 297;
var SCROLLER_OFFSET = 81;
var startY=0;

///////////////////////////////////////
// Frame IDs
///////////////////////////////////////
var ADD_FRAME = 1;
var REMINDER_FRAME = 2;
var DELETE_FRAME = 3;
var ERROR_FRAME = 4;
var NO_FRAME = 5;

var MAX_EVENT_NAME_LEN = 30;
var MAX_EVENT_REMINDER_LEN = 2;
var showMainPromo;

function loc(str) {
    return widget.getLocalizedString(str);
}

function AnyEvent(eventId, general, eventDate) {
    this.eventId = eventId;
    this.general = general;
    this.eventDate = eventDate;
}

function ReminderData(eventId, general, remindDate) {
    this.eventId = eventId;
    this.general = general;
    this.remindDate = remindDate;
}

function GeneralEvent (date, title, text, enable, enableReminder, snoozeTime, snoozeUnits) {
    this.date = date;
    this.title = title;
    this.text = text;
    this.enable = enable;
    this.enableReminder = enableReminder;
    this.snoozeTime = snoozeTime;
    this.snoozeUnits = snoozeUnits;
};

function UserEvent(name, date, allDay, happens, remindTime, remindUnits, audio, sound, enableReminder, snoozeTime, snoozeUnits, nextOccurence) {
    this.name = name;
    this.date = date;
    this.allDay = allDay;
    this.happens = happens;
    this.remindTime = remindTime;
    this.remindUnits = remindUnits;
    this.audio = audio;
    this.sound = sound;
    this.enableReminder = enableReminder;
    this.snoozeTime = snoozeTime;
    this.snoozeUnits = snoozeUnits;
    this.nextOccurence = nextOccurence;
}

function firstRun() {
    firstRunTimer.ticking=false;
    if (!bFirstRunComplete) {
        if (system.platform == "macintosh")
            DIRECTORY_DIV = "/";

        bFirstRunComplete=true;

        // Hide unused elements
        showMainPromo = true;

        setImagesByLang();

        copyGeneralData();
        parseGeneralData();
        parseUserData();

        updatePromo();

        selectGenHolidaysForPeriod();
        compileArrayOfEvents();

        frameInfoAndGeneral.visible = true;
        if (numberOfPromos > 0)
            framePromo.visible = true;

        displayGeneralInfo();

        // Display all items in chronological order (3 of them at a time)
        currentOffset = 0;
        displayItems(currentOffset);
        checkReminders();
    }
}

function updatePromo() {
    getNumberOfPromos();
    displayPromoButtons();
    displayPromoInfo();
    displayItems(currentOffset);
}

function setImagesByLang() {
    imageHeader.src = loc("imageHeader");
    imageTips.src = loc("imageTips");
    setImage2Pictures(imageAddEvent, loc("addEvent"), loc("addEvent.rollover"));
    setImage2Pictures(imageItem1Edit, loc("edit"), loc("edit.rollover"));
    setImage2Pictures(imageItem2Edit, loc("edit"), loc("edit.rollover"));
    setImage2Pictures(imageItem3Edit, loc("edit"), loc("edit.rollover"));
    imageHeaderAdd.src = loc("imageHeaderAdd");
    imageHeaderEdit.src = loc("imageHeaderEdit");
    setImage2Pictures(imageCancel, loc("addEvent.cancel"), loc("addEvent.cancel.rollover"));
    setImage2Pictures(imageSaveAdd, loc("addEvent.saveandadd"), loc("addEvent.saveandadd.rollover"));
    setImage2Pictures(imageSave, loc("addEvent.save"), loc("addEvent.save.rollover"));
    setImage2Pictures(imageSaveEdit, loc("addEvent.save"), loc("addEvent.save.rollover"));
    setImage2Pictures(imageDay, loc("addEvent.day"), loc("addEvent.day.rollover"));
    setImage2Pictures(imageMonth, loc("addEvent.month"), loc("addEvent.month.rollover"));
    setImage2Pictures(imageYear, loc("addEvent.year"), loc("addEvent.year.rollover"));
    setImage2Pictures(imageHour, loc("addEvent.hour"), loc("addEvent.hour.rollover"));
    setImage2Pictures(imageMinute, loc("addEvent.minute"), loc("addEvent.minute.rollover"));
    setImage2Pictures(imageAMPM, loc("addEvent.ampm"), loc("addEvent.ampm.rollover"));
    setImage2Pictures(imageHappens, loc("addEvent.happens"), loc("addEvent.happens.rollover"));
    setImage2Pictures(imageSound, loc("addEvent.sound"), loc("addEvent.sound.rollover"));
    imageReminderHeader.src = loc("imageHeaderReminder");
    setImage2Pictures(imageDisable, loc("reminder.disable"), loc("reminder.disable.rollover"));
    setImage2Pictures(imageSetSnooze, loc("reminder.snooze"), loc("reminder.snooze.rollover"));
    imageErrorHeader.src = loc("imageErrorHeader");
    setImage2Pictures(imageKeepOpen, loc("imageKeepOpen"), loc("imageKeepOpen.rollover"));
    setImage2Pictures(imageCloseIt, loc("imageCloseIt"), loc("imageCloseIt.rollover"));
    imageDeleteHeader.src = loc("imageDeleteHeader");
    setImage2Pictures(imageKeep, loc("imageKeep"), loc("imageKeep.rollover"));
    setImage2Pictures(imageRemove, loc("imageRemove"), loc("imageRemove.rollover"));
    imageBox.src = loc("audioBgnd");
    if (isFrenchLocale()) {
        audioOn.hOffset = 190;
        audioOff.hOffset = 190;
        eventAMPM.visible =  false;
        imageAMPM.visible = false;
    } else {
        imageMonth.hOffset -= 20;
        eventMonth.hOffset -= 20;
        imageMinute.hOffset -= 20;
        eventMinute.hOffset -= 20;
    }
}

function setImage2Pictures(image, regPic, rolloverPic) {
    image.src =  loc(regPic);
    image.onMouseExit = function() { image.src=loc(regPic); };
    image.onMouseEnter = function() { image.src=loc(rolloverPic); };
}

function displayItems(offset) {
    showMainScreenPromo(showMainPromo);
    showItem(false, 1, false);
    showItem(false, 2, false);
    showItem(false, 3, false);
    showAdd(false, 2);
    showAdd(false, 3);

    var mainPromoOffset = 0;
    if (showMainPromo) {
        mainPromoOffset = 2;
    }

    var maxLen = offset + 3 - mainPromoOffset;
    var emptySpaces = 0;
    if (anyEventData.length < offset + 3) {
        if (!showMainPromo || anyEventData.length==0)
            maxLen = anyEventData.length;

        emptySpaces = offset + 3 - maxLen;
        if (showMainPromo)
            emptySpaces -= 2;
    }
    if (emptySpaces == 3)
        emptySpaces--;  // We can have only 2 empty spaces

    for (var i=offset; i< maxLen; i++) {
        if (anyEventData[i].general) {
            displayGeneralEvent(i-offset + 1 + mainPromoOffset, anyEventData[i].eventId);
        } else {
            displayUserEvent(i-offset + 1 + mainPromoOffset, anyEventData[i].eventId);
        }
    }
    // If less than 3 items in general and user, display place-holders for add
    for (i = 4 - emptySpaces; i <=3; i++) {
        showAdd(true, i);
    }

    if (showMainPromo)
        frameInfoAndGeneral.getElementById("imageAdd2Div").visible = true; 
}

function compareDates(a, b) {
    if (a.eventDate < b.eventDate)
        return -1;
    else if (a.eventDate == b.eventDate)
        return 0;
    else
        return 1;
}

function compileArrayOfEvents() {
    for (var i=0; i < currentHolidays.length;i++) {
        anyEventData[anyEventData.length] = new AnyEvent(currentHolidays[i], true, generalData[currentHolidays[i]].date);
    }
    for (i=0; i < userData.length;i++) {
        anyEventData[anyEventData.length] = new AnyEvent(i, false, userData[i].date);
    }
    anyEventData.sort(compareDates);
}

function compileArrayOfReminders() {
    reminderData.remove(reminderData, 0, reminderData.length - 1);
    for (var i=0; i < currentHolidays.length;i++) {
        if (!generalData[currentHolidays[i]].enableReminder)
            continue;

        var generalReminder = getGeneralReminder(generalData[currentHolidays[i]]);
        if (generalReminder != null)
            reminderData[reminderData.length] = new ReminderData(currentHolidays[i], true, generalReminder);
    }
    for (i=0; i < userData.length;i++) {
        if (userData[i] == null)
            continue;
        if (!userData[i].enableReminder)
            continue;
        
        var userReminder = getUserReminder(userData[i]);
        if (userReminder != null)
            reminderData[reminderData.length] = new ReminderData(i, false, userReminder);
    }
    reminderData.sort(compareDates);
}

function getGeneralReminder(generalEvent) {
    var genReminder = new Date(generalEvent.date.getFullYear() + "/" + (generalEvent.date.getMonth() + 1) + "/" +
                               generalEvent.date.getDate() + " " + GEN_HOLIDAY_REMIND_TIME);
    genReminder.setDate(genReminder.getDate() - GEN_HOLIDAY_PERIOD);
    var eventTime = genReminder.getTime();
    if (generalEvent.snoozeTime != "" && generalEvent.snoozeUnits != "")
        eventTime = applySnooze(eventTime, generalEvent.snoozeTime, generalEvent.snoozeUnits, true);
    return genReminder.setTime(eventTime);
}

function getUserReminder(userEvent) {
    var userReminder = new Date();
    if (userEvent.nextOccurence != null && userEvent.nextOccurence != '') {
        userReminder.setTime(userEvent.nextOccurence.getTime());
    } else {
        var eventTime = userEvent.date.getTime();
        eventTime = applySnooze(eventTime, userEvent.remindTime, userEvent.remindUnits, false);
        if (userEvent.snoozeTime != "" && userEvent.snoozeUnits != "")
            eventTime = applySnooze(eventTime, userEvent.snoozeTime, userEvent.snoozeUnits, true);
        userReminder.setTime(eventTime);
    }
    return userReminder;
}

function eventHappensOnce(happens) {
    return (happens == loc("happens.Once"));
}

function applyHappensToTime(happens, time) {
    var reminderTime = new Date(time);
    var nowBasedOnTime = getNowBasedOnTime(reminderTime);
    // Check happens
    if (eventHappensOnce(happens)) {
        // Nothing to do
    } else if (happens == loc("happens.Daily")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + 1);
        reminderTime.setTime(nowBasedOnTime.getTime());     // Set it for tomorrow
    } else if (happens == loc("happens.Weekdays")) {
        // For Friday and Saturday - set to
        if (nowBasedOnTime.getDay() == 5)
            nowBasedOnTime.setDate(nowBasedOnTime.getDate() + 3);
        else if (nowBasedOnTime.getDay() == 6)
            nowBasedOnTime.setDate(nowBasedOnTime.getDate() + 2);
        else
            nowBasedOnTime.setDate(nowBasedOnTime.getDate() + 1);
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Mondays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 1));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Tuesdays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 2));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Wednesdays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 3));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Thursdays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 4));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Fridays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 5));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Saturdays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 6));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Sundays")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), 0));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Weekly")) {
        nowBasedOnTime.setDate(nowBasedOnTime.getDate() + calculateDays(nowBasedOnTime.getDay(), reminderTime.getDay()));
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Monthly")) {
        nowBasedOnTime.setMonth(nowBasedOnTime.getMonth() + 1);
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else if (happens == loc("happens.Yearly")) {
        nowBasedOnTime.setMonth(reminderTime.getMonth());
        nowBasedOnTime.setFullYear(nowBasedOnTime.getFullYear() + 1);
        reminderTime.setTime(nowBasedOnTime.getTime());
    } else {
        // Nothing to do
    }
    return reminderTime;
}

function getNowBasedOnTime(date) {
    var nowTime = new Date();
    nowTime.setHours(date.getHours());
    nowTime.setMinutes(date.getMinutes());
    return nowTime;
}

function calculateDays(current, needed) {
    var delta = needed - current;
    if (delta <= 0) {
        delta += 7;
    }
    return delta;
}

function copyGeneralData() {
    try {
        print(system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML);
        if (!filesystem.itemExists(system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML)) {
            print('file doesn\'t exist, copy \'' + GENERAL_DATA_DIR + GENERAL_DATA_XML + '\' to \'' + system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML + '\'');
            filesystem.copy(GENERAL_DATA_DIR + GENERAL_DATA_XML, system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML);
        }
    } catch(e) {
        print(e);
    }
}

function selectGenHolidaysForPeriod() {
    var today = new Date();
    var endOfPeriod = new Date();
    endOfPeriod.setDate(endOfPeriod.getDate() + GEN_HOLIDAY_PERIOD);

    for (var i = 0; i < generalData.length; i++) {
        var holiday = generalData[i];
        if (today.getTime() <= holiday.date.getTime() && holiday.date.getTime() <= endOfPeriod.getTime() && holiday.enable) {
            currentHolidays[currentHolidays.length] = i;
        }
    }
}

function displayGeneralInfo() {
    summerTitle.data = loc("summer.title");
    summerText.data = loc("summer.text");
}

function parseGeneralData() {
    try {
        var dom = XMLDOM.parse(filesystem.readFile(system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML));
        var nodes = dom.getElementsByName("events").item(0).childNodes;
        var counter = 0;
        for (var i = 0; i < nodes.length; i++) {
            var item = nodes.item(i);
            if (item.nodeType != 8) {
                var attributes = item.attributes;
                var enable = (findAttribute(attributes, "enable") == "true");
                var enableReminder = (findAttribute(attributes, "enableReminder") == "true");
                generalData[counter++] = new GeneralEvent(new Date(findAttribute(attributes, "date")),
                        findAttribute(attributes, "title"), findAttribute(attributes, "text"), enable, enableReminder,
                        findAttribute(attributes, "snoozeTime"), findAttribute(attributes, "snoozeUnits"));
            }
        }
    }
    catch (e) {
        print(e);
    }
}

function parseUserData() {
    try {
        var dom = XMLDOM.parse(filesystem.readFile(system.widgetDataFolder + DIRECTORY_DIV + USER_DATA_XML));
        var nodes = dom.getElementsByName("events").item(0).childNodes;
        for (var i = 0; i < nodes.length; i++) {
            var item = nodes.item(i);
            if (item.nodeType != 8) {
                userData[i] = createUserEvent(item.attributes);
            }
        }
    }
    catch (e) {
        print(e);
    }
}

function createUserEvent(attributes) {
    var allDay = (findAttribute(attributes, "allDay") == "true");
    var audio = (findAttribute(attributes, "audio") == "true");
    var enableReminder = (findAttribute(attributes, "enableReminder") == "true");
    return new UserEvent(findAttribute(attributes, "name"),createDateFromStr(findAttribute(attributes, "date")),
            allDay,findAttribute(attributes, "happens"), findAttribute(attributes, "remindTime"),
            findAttribute(attributes, "remindUnits"),audio, findAttribute(attributes, "sound"), enableReminder,
            findAttribute(attributes, "snoozeTime"), findAttribute(attributes, "snoozeUnits"),
            createDateFromStr(findAttribute(attributes, "nextOccurence")));
}

function createDateFromStr(strDate) {
    if (strDate != "") {
        return new Date(strDate);
    } else {
        return null;
    }
}

function findAttribute(attributes, attName) {
    for (i=0; i<attributes.length; i++) {
        if (attributes.item(i).name == attName) {
            return attributes.item(i).value;
        }
    }
    return "";
}

function saveUserData() {
    backupOldUserData();
    storeNewUserData();
}

function saveGeneralData() {
    backupGeneralData();
    storeNewGeneralData();
}

function backupOldUserData() {
    try {
        if (filesystem.itemExists(system.widgetDataFolder + DIRECTORY_DIV + USER_DATA_XML))
            filesystem.copy(system.widgetDataFolder + DIRECTORY_DIV + USER_DATA_XML, system.widgetDataFolder + DIRECTORY_DIV + USER_DATA_BACKUP_XML);
    } catch(e) {
        print(e);
    }
}

function backupGeneralData() {
    try {
        if (filesystem.itemExists(system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML))
            filesystem.copy(system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML, system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_BACKUP_XML);
    } catch(e) {
        print(e);
    }
}

function formatMinutes(minutes) {
    var prefix = "0";
    if (minutes >= 10)
        prefix = "";

    return prefix + minutes;
}

function getDateAsStr(dateToStr) {
    if (dateToStr != null && dateToStr != "") {
        return dateToStr.getFullYear() + "/" + (dateToStr.getMonth() + 1) + "/" + dateToStr.getDate() + " " + dateToStr.getHours() + ":" + formatMinutes(dateToStr.getMinutes());
    } else {
        return "";
    }
}

/////////////////////////////////////////////////
// Create new user data and store it to file 
/////////////////////////////////////////////////
function storeNewUserData() {
    try {
        doc = XMLDOM.createDocument();
        events = doc.createElement("events");

        for (var i = 0; i < userData.length; i++) {
            var userDataItem = userData[i];
            if (userDataItem == null)
                continue;

            event = doc.createElement("event");
            attributes = doc.createAttribute("name");
            attributes.value = userDataItem.name;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("date");
            attributes.value = getDateAsStr(userDataItem.date);
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("allDay");
            attributes.value = userDataItem.allDay;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("happens");
            attributes.value = userDataItem.happens;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("remindTime");
            attributes.value = userDataItem.remindTime;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("remindUnits");
            attributes.value = userDataItem.remindUnits;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("audio");
            attributes.value = userDataItem.audio;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("sound");
            attributes.value = userDataItem.sound;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("enableReminder");
            attributes.value = userDataItem.enableReminder;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("snoozeTime");
            attributes.value = userDataItem.snoozeTime;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("snoozeUnits");
            attributes.value = userDataItem.snoozeUnits;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("nextOccurence");
            attributes.value = getDateAsStr(userDataItem.nextOccurence);
            event.setAttributeNode(attributes);

            events.appendChild(event);
        }
        doc.appendChild(events);
        filesystem.writeFile(system.widgetDataFolder + DIRECTORY_DIV + USER_DATA_XML, doc.toXML());
    } catch(e) {
        print(e);
    }
}

/////////////////////////////////////////////////
// Create new general data and store it to file
/////////////////////////////////////////////////
function storeNewGeneralData() {
    try {
        doc = XMLDOM.createDocument();
        events = doc.createElement("events");

        for (var i = 0; i < generalData.length; i++) {
            var genDataItem = generalData[i];
            event = doc.createElement("event");
            attributes = doc.createAttribute("date");
            attributes.value = genDataItem.date.getFullYear() + "/" + (genDataItem.date.getMonth() + 1) + "/" +
                               genDataItem.date.getDate();
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("title");
            attributes.value = genDataItem.title;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("text");
            attributes.value = genDataItem.text;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("enable");
            attributes.value = genDataItem.enable;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("enableReminder");
            attributes.value = genDataItem.enableReminder;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("snoozeTime");
            attributes.value = genDataItem.snoozeTime;
            event.setAttributeNode(attributes);

            attributes = doc.createAttribute("snoozeUnits");
            attributes.value = genDataItem.snoozeUnits;
            event.setAttributeNode(attributes);

            events.appendChild(event);
        }
        doc.appendChild(events);
        filesystem.writeFile(system.widgetDataFolder + DIRECTORY_DIV + GENERAL_DATA_XML, doc.toXML());
    } catch(e) {
        print(e);
    }
}

/////////////////////////////////////////////////
// Get number of promos
/////////////////////////////////////////////////
function getNumberOfPromos() {
    var tryNextPromo = true;
    numberOfPromos = 0;
    while (tryNextPromo) {
        if (loc("promo.title."+numberOfPromos) != "promo.title."+numberOfPromos)
            numberOfPromos++;
        else
            tryNextPromo = false;
    };
    if (!showMainPromo)
        numberOfPromos++;
}

function displayPromo(delta) {
    if (currentPromo + delta == numberOfPromos)
        currentPromo = 0;
    else if (currentPromo + delta == -1)
        currentPromo = numberOfPromos - 1;
    else
        currentPromo = currentPromo + delta;
    displayPromoInfo();
}

function displayPromoInfo() {
    if ((currentPromo == numberOfPromos - 1) && !showMainPromo) {
        promoTitle.text = loc("summer.title").toUpperCase();
        promoText.text = loc("summer.text.promo");
        promoImage.src = loc("summer.promo.image");
        promoText.onClick = openPromotionURL;
        promoImage.onClick = openPromotionURL;
    } else {
        promoTitle.text = loc("promo.title."+currentPromo);
        promoText.text = loc("promo.text."+currentPromo);
        promoImage.src = loc("promo.image."+currentPromo);
        promoText.onClick = openPromoURL;
        promoImage.onClick = openPromoURL;
    }
    promoText.vOffset = promoTitle.vOffset + promoTitle.height + 5;
    promoImage.hOffset = 100 - promoImage.width;
}

function displayPromoButtons() {
    var displayButtons = false;
    if (numberOfPromos > 1) {
        displayButtons = true;
    }

    if (displayButtons) {
        showPrev();
        showNext();
    } else {
        hidePrev();
        hideNext();
    }
}

function showPrev() {
    imageBtnPrevOff.visible = false;
    imageBtnPrev.visible = true;
}

function hidePrev() {
    imageBtnPrevOff.visible = true;
    imageBtnPrev.visible = false;
}

function showNext() {
    imageBtnNextOff.visible = false;
    imageBtnNext.visible = true;
}

function hideNext() {
    imageBtnNextOff.visible = true;
    imageBtnNext.visible = false;
}

function openAddEventFrame() {
    hideMainPromo();

    clearEventData();
    displayFrame(ADD_FRAME);
}

function displayEventLabels() {
    eventNameLbl.data = loc("event.name");
    eventDateLbl.data = loc("event.date");
    eventTimeLbl.data = loc("event.time");
    allDayLbl.data = loc("event.allDay");
    eventHappensLbl.data = loc("event.happens");
    eventRemindMeLbl1.data = loc("event.remindMe1");
    eventRemindMeLbl2.data = loc("event.remindMe2");
    eventAudioLbl1.data = loc("audio.label");
    eventAudioLbl1_1.data = loc("audio.label_1");
    eventAudioLbl2.data = loc("audio.on");
    eventAudioLbl3.data = loc("audio.off");
    eventAudioLbl4.data = loc("audio.choose.sound");
    eventName.focus();
}

function isFrenchLocale() {
    return (widget.locale.substr( 0, 2 ) == "fr");
}

function displayEventData(userEventId) {
    var userEvent = userData[userEventId];
    eventName.data = userEvent.name;
    eventDay.data = userEvent.date.getDate();
    eventMonth.data = getMonthName(userEvent.date.getMonth());
    eventYear.data = userEvent.date.getFullYear();
    var hours = userEvent.date.getHours();

    if (isFrenchLocale()) {
        eventHour.data = hours;
    } else {
        if (hours >= 12) {
            eventHour.data = hours - 12;
            eventAMPM.data = loc("ampm.pm");
        } else {
            eventHour.data = hours;
            eventAMPM.data = loc("ampm.am");
        }
    }
    var minutes = userEvent.date.getMinutes();
    if (minutes < 10)
        minutes = "0" + minutes;
    eventMinute.data = minutes;
    eventRemindMe.data = userEvent.remindTime;
    eventHappens.data = userEvent.happens;
    eventRemindMeTime.data = userEvent.remindUnits;
    eventSound.data = userEvent.sound;
    selectAllDay(userEvent.allDay);
    selectAudio(userEvent.audio);
    setEventHeader(false);
    imageSaveEdit.onClick = function (userEventId) {
        return function() {
            saveEdit(userEventId);
        };
    }(userEventId);
}

function setEventHeader(add) {
    imageHeaderAdd.visible = add;
    imageHeaderEdit.visible = !add;
    imageSaveAdd.visible = add;
    imageSave.visible = add;
    imageSaveEdit.visible = !add;
    if (add) {
        selectAudio(false);
        selectAllDay(false);
    }
}

function clearEventData() {
    // Set labels by language
    displayEventLabels();

    // Clear data fields
    eventName.data = "";
    var now = new Date();
    var minutes = "30";
    if (now.getMinutes() > 30) {
        now.setMinutes(30);
        minutes = "00";
    }
    else
        now.setMinutes(0);
    now.setMinutes(now.getMinutes() + 30);
    eventDay.data = now.getDate();
    eventMonth.data = getMonthName(now.getMonth());
    eventYear.data = now.getFullYear();
    if (isFrenchLocale()) {
        eventHour.data = now.getHours();
        eventMinute.data = minutes;
        eventAMPM.visible =  false;
        imageAMPM.visible = false;
    } else {
        var hours = now.getHours();
        if (hours < 12) {
            if (hours == 0) {
                eventHour.data = "12";
            } else {
                eventHour.data = hours;
            }
            eventAMPM.data = loc("ampm.am");
        } else {
            if (hours == 12) {
                eventHour.data = "12";
            } else {
                eventHour.data = hours - 12;
            }
            eventAMPM.data = loc("ampm.pm");
        }
        eventMinute.data = minutes;
    }
    eventRemindMe.data = loc("remindTime.default.value");
    eventHappens.data = loc( "happens.default" );
    eventRemindMeTime.data = loc("remindTime.Minutes");
    eventSound.data = loc("sound.default");
    setEventHeader(true);
}

function closeAddEventFrame () {
    clearEventData();
    displayFrame(NO_FRAME);
}

function cancelEvent() {
    clearEventData();
    displayFrame(NO_FRAME);
}

function saveAdd() {
    if (saveEvent(null)) {
        clearEventData();
    }
}

function saveEdit(userEventId) {
    if (saveEvent(userEventId)) {
        displayFrame(NO_FRAME);
    }
}

function save() {
    if (saveEvent(null)) {
        clearEventData();
        displayFrame(NO_FRAME);
    }
}

function saveEvent(userEventId) {
    if (allDataEntered()) {
        var date = createDate(eventDay.data,eventMonth.data,eventYear.data, eventHour.data,eventMinute.data,eventAMPM.data);
        var nowDate = new Date();
        if (date < nowDate) {
            if (alert(loc("date.is.before.now"), loc("alert.yes.date"), loc("alert.no.date")) == 2) {
                return false;
            }
        }
        var newEvent = new UserEvent(eventName.data, date, isAllDay(), eventHappens.data, eventRemindMe.data,
                eventRemindMeTime.data, isAudio(), eventSound.data, true, "", "", "");
        if (userEventId != null) {
            userData[userEventId] = newEvent;
            removeItemAndRefreshDisplay(userEventId, false, true);
            anyEventData[anyEventData.length] = new AnyEvent(userEventId, false, userData[userEventId].date);
        } else {
            userData[userData.length] = newEvent;
            anyEventData[anyEventData.length] = new AnyEvent(userData.length - 1, false, userData[userData.length - 1].date);
        }
        saveUserData();
        // Add new event to list of displayed events, sort array and refresh display
        anyEventData.sort(compareDates);
        displayItems(currentOffset);

        return true;
    } else {
        alert(loc("enter.all.data.add"));
        return false;
    }
}

function isAllDay() {
    return (allDayImage.src == "Resources/images/add_event/MLF_widget_addevent_checkbox_on.png");
}

function isAudio() {
    return (audioOnRadio.src == "Resources/images/add_event/MLF_widget_addevent_radiobtn_on.png");
}

function getMonthNumber(month) {
    if (month == loc("month.January"))
        return 1;
    else if (month == loc("month.February"))
        return 2;
    else if (month == loc("month.March"))
        return 3;
    else if (month == loc("month.April"))
        return 4;
    else if (month == loc("month.May"))
        return 5;
    else if (month == loc("month.June"))
        return 6;
    else if (month == loc("month.July"))
        return 7;
    else if (month == loc("month.August"))
        return 8;
    else if (month == loc("month.September"))
        return 9;
    else if (month == loc("month.October"))
        return 10;
    else if (month == loc("month.November"))
        return 11;
    else if (month == loc("month.December"))
        return 12;
    else
        return 1;
}

function getMonthName(month) {
    if (month == 0)
        return loc("month.January");
    else if (month == 1)
        return loc("month.February");
    else if (month == 2)
        return loc("month.March");
    else if (month == 3)
        return loc("month.April");
    else if (month == 4)
        return loc("month.May");
    else if (month == 5)
        return loc("month.June");
    else if (month == 6)
        return loc("month.July");
    else if (month == 7)
        return loc("month.August");
    else if (month == 8)
        return loc("month.September");
    else if (month == 9)
        return loc("month.October");
    else if (month == 10)
        return loc("month.November");
    else if (month == 11)
        return loc("month.December");
    else
        return loc("month.January");
}

function createDate(day, month, year, hour, minute, ampm) {
    var date;
    if (isFrenchLocale())
        date = new Date(getMonthNumber(month) + " " + day + ", " + year + " " + hour + ":" + minute);
    else
        date = new Date(getMonthNumber(month) + " " + day + ", " + year + " " + hour + ":" + minute + " " + ampm);
    return date;
}

function allDataEntered() {
    return !(eventName.data == "" || eventHappens.data == loc( "happens.default" ) || (isAudio() && eventSound.data == loc("sound.default")));
}

function makeMenu( popupList, elem)
{
    items = new Array;
    for ( menuCount = 0; menuCount < popupList.length; menuCount++ )
    {
        var item = new MenuItem( );
        item.title = popupList[ menuCount ];
        item.enabled = true;
        if (elem.data == popupList[ menuCount ]) {
            item.onSelect = function () {};
            item.checked = true;
        } else {
            item.onSelect = function(i) {
                return function() {
                    elem.data = items[i].title;
                };
            } (menuCount);
            item.checked = false;
        }
        items.push(item);
    }
    popupMenu( items, frameAddEvent.hOffset + elem.hOffset, frameAddEvent.vOffset + elem.vOffset + 15);
}

function selectDay() {
    var popupList = new Array;
    for (var i=1; i<= 31; i++)
        popupList[i-1] = i;
    makeMenu(popupList, eventDay);
}

function selectMonth() {
    var popupList = [loc("month.January"),loc("month.February"),loc("month.March"),loc("month.April"),
        loc("month.May"),loc("month.June"),loc("month.July"),loc("month.August"),
        loc("month.September"),loc("month.October"),loc("month.November"),loc("month.December")];
    makeMenu(popupList, eventMonth);
}

function selectYear() {
    var popupList = new Array;
    for (var i=2009; i<= 2012; i++)
        popupList[i-2009] = i;
    makeMenu(popupList, eventYear);
}

function selectHour() {
    var popupList = new Array;
    var max_hours = 12;
    var min_hours = 1;
    if (isFrenchLocale()) {
        max_hours = 23;
        min_hours = 0;
    }
    for (var i=min_hours; i<= max_hours; i++)
        popupList[i-min_hours] = i;
    makeMenu(popupList, eventHour);
}

function selectMinute() {
    var popupList = new Array;
    for (var i=0; i< 60; i++) {
        var min = i;
        if (i < 10)
            min = '0' + min;
        popupList[i] = min;
    }
    makeMenu(popupList, eventMinute);
}

function selectAMPM() {
    var popupList = [loc("ampm.am"),loc("ampm.pm")];
    makeMenu(popupList, eventAMPM);
}

function selectHappens() {
    var popupList = [loc("happens.Once"),loc("happens.Daily"),loc("happens.Weekdays"),loc("happens.Mondays"),
        loc("happens.Tuesdays"),loc("happens.Wednesdays"),loc("happens.Thursdays"),loc("happens.Fridays"),
        loc("happens.Saturdays"),loc("happens.Sundays"),loc("happens.Weekly"),loc("happens.Monthly"),loc("happens.Yearly")];
    makeMenu(popupList, eventHappens);
}

function selectRemindMe() {
    var popupList = [loc("remindTime.Minutes"),loc("remindTime.Hours"),loc("remindTime.Days")];
    makeMenu(popupList, eventRemindMeTime);
}

function selectSound() {
    var popupList = [loc("sound.Summer"),loc("sound.Autumn"),loc("sound.Winter"),loc("sound.Spring")];
    makeMenu(popupList, eventSound);
}

function selectAudio(audioValue) {
    if (audioValue) {
        audioOnRadio.src = "Resources/images/add_event/MLF_widget_addevent_radiobtn_on.png";
        audioOffRadio.src = "Resources/images/add_event/MLF_widget_addevent_radiobtn_off.png";
    } else {
        audioOnRadio.src = "Resources/images/add_event/MLF_widget_addevent_radiobtn_off.png";
        audioOffRadio.src = "Resources/images/add_event/MLF_widget_addevent_radiobtn_on.png";
    }
}

function selectAllDay(allDay) {
    if (allDay) {
        allDayImage.src = "Resources/images/add_event/MLF_widget_addevent_checkbox_on.png";
    } else {
        allDayImage.src = "Resources/images/add_event/MLF_widget_addevent_checkbox_off.png";
    }
}

function switchSelectAllDay() {
    return selectAllDay(!isAllDay());
}

function openReminderFrame() {
    widget.visible = true;
    setDefaultReminderData();
    displayReminderButtons();
    displayFrame(REMINDER_FRAME);
}

function closeReminderFrame () {
    displayFrame(NO_FRAME);
}

function disableReminder() {
    var reminder = reminderData[reminderToDisplay[currentReminder]];
    if (reminder.general || eventHappensOnce(userData[reminder.eventId].happens)) {
        if (alert(loc("are.you.sure.disable.reminder"), loc("alert.yes.disable"), loc("alert.no.disable")) == 2)
            return;
    }

    // Disable reminder for event
    if (reminder.general) {
        generalData[reminder.eventId].enableReminder = false;
        saveGeneralData();
    } else {
        var happens = userData[reminder.eventId].happens;
        if (eventHappensOnce(happens)) {
            userData[reminder.eventId].enableReminder = false;
        } else {
            // ask if users want to disable it completely or till next event occurrence
            var res = alert(loc("delete.occurence"), loc("delete.this.occurence"), loc("delete.series"), loc("alert.no.disable"));
            if (res == 2) {
                userData[reminder.eventId].enableReminder = false;
            } else if (res == 1) {
                // Event happens multiple times, postpone it till next time
                userData[reminder.eventId].nextOccurence = applyHappensToTime(happens, reminder.remindDate);
            } else
                return;
        }

        saveUserData();
    }

    currentReminder = 0;
    closeReminderFrame();
    checkReminders();   // In case we have more than one reminder
}

function setSnooze() {
    var snoozeTime = remindNumber.data;
    var snoozeUnits = remindTime.data;
    // Disable reminder for event
    var reminder = reminderData[reminderToDisplay[currentReminder]];
    if (reminder.general) {
        generalData[reminder.eventId].snoozeTime = snoozeTime;
        generalData[reminder.eventId].snoozeUnits = snoozeUnits;
        saveGeneralData();
    } else {
        userData[reminder.eventId].snoozeTime = snoozeTime;
        userData[reminder.eventId].snoozeUnits = snoozeUnits;
        saveUserData();
    }
    reminder.remindDate = applySnooze(reminder.remindDate, snoozeTime, snoozeUnits, true);

    closeReminderFrame();
}

function applySnooze(reminder, snoozeTime, snoozeUnits, forward) {
    var multiplier = -1;
    if (forward)
        multiplier = 1;

    if (snoozeUnits == loc("remindTime.Minutes")) {
        reminder = reminder + (multiplier) * snoozeTime * REMIND_MINUTES;
    } else if (snoozeUnits == loc("remindTime.Hours")) {
        reminder = reminder + (multiplier) * snoozeTime * REMIND_HOURS;
    } else if (snoozeUnits == loc("remindTime.Days")) {
        reminder = reminder + (multiplier) * snoozeTime * REMIND_DAYS;
    } else {
        alert(loc("wrong.remindTime.units"));
        return null;
    }
    return reminder;
}

function selectNumber() {
    var popupList = new Array;
    for (var i=1; i<= 30; i++)
        popupList[i-1] = i;
    makeMenu(popupList, remindNumber);
}

function selectTime() {
    var popupList = [loc("remindTime.Minutes"),loc("remindTime.Hours"),loc("remindTime.Days")];
    makeMenu(popupList, remindTime);
}

function setDefaultReminderData() {
    remindAgainLbl.data = loc("remind.me.again");
    remindTime.data = loc("remindTime.Minutes");
    remindNumber.data = loc("remindTime.default.value");
}

function openErrorFrame() {
    setDefaultErrorData();
    displayFrame(ERROR_FRAME);
}

function setDefaultErrorData() {
    errorMessage.data = loc("are.you.sure.text");
}

function keepOpen() {
    displayFrame(NO_FRAME);
}

function closeIt() {
    displayFrame(NO_FRAME);
    widget.visible = false;
}

/////////////////////////////////////////////////
// Display general event: close button, title and text
// id - placeholder ID (1, 2 or 3)
// genEventID - Id of general event
/////////////////////////////////////////////////
function displayGeneralEvent(id, genEventID) {
    setGeneralItemData(id, genEventID);
    showItem(true, id, true);
}

function setGeneralItemData(id, genEventID) {
    frameInfoAndGeneral.getElementById("imageItem"+id+"Close").onClick = function() {deleteEvent(genEventID, true)};
    frameInfoAndGeneral.getElementById("item"+id+"Title").data = generalData[genEventID].title;
    frameInfoAndGeneral.getElementById("item"+id+"Line1").data = generalData[genEventID].text;
}

/////////////////////////////////////////////////
// Remove event by id and flag (true - for general, false - otherwise)
/////////////////////////////////////////////////
function deleteEvent(eventID, general) {
    var eventName;
    if (general) {
        eventName = generalData[eventID].title;
    } else {
        eventName = userData[eventID].name;
    }
    deleteEventText.data = loc("are.you.sure.remove.text1") + eventName + loc("are.you.sure.remove.text2");
    displayFrame(DELETE_FRAME);

    imageRemove.onClick = function(eventID, general) {
        return function() {
            if (general) {
                deleteGeneralEvent(eventID);
            } else {
                deleteUserEvent(eventID);
            }
            displayFrame(NO_FRAME);
        };
    } (eventID, general);
}

function deleteGeneralEvent(id) {
    generalData[id].enable = false;
    saveGeneralData();
    displayFrame(NO_FRAME);
    removeItemAndRefreshDisplay(id, true, true);
}

function deleteUserEvent(id) {
    userData[id] = null;
    saveUserData();
    displayFrame(NO_FRAME);
    if (getNumberOfUserEvent() == 3) {
        if (currentOffset != 0)
            currentOffset--;
        imageScroller.vOffset = TOP_SCROLLER_POSITION;
    }
    removeItemAndRefreshDisplay(id, false, true);
}

// Array Remove - By John Resig (MIT Licensed) - http://ejohn.org/blog/javascript-array-remove/
Array.prototype.remove = function(array, from, to) {
  var rest = array.slice((to || from) + 1 || array.length);
  array.length = from < 0 ? array.length + from : from;
  return array.push.apply(array, rest);
};

function removeItemAndRefreshDisplay(id, general, refresh) {
    // Find item by id and general and remove it from array
    for (var i=0; i < anyEventData.length; i++) {
        if (anyEventData[i].eventId == id && anyEventData[i].general == general) {
            anyEventData.remove(anyEventData,  i);
            if (refresh)
                displayItems(currentOffset);
            break;
        }
    }
    hideMainPromo();
}

/////////////////////////////////////////////////
// Display user event: close and edit buttons, title and text
// id - placeholder ID (1, 2 or 3)
// userEventID - Id of user event
/////////////////////////////////////////////////
function displayUserEvent(id, userEventID) {
    setUserItemData(id, userEventID);
    showItem(true, id, false);
}

function setUserItemData(id, userEventID) {
    frameInfoAndGeneral.getElementById("imageItem"+id+"Close").onClick = function() {deleteEvent(userEventID, false)};
    frameInfoAndGeneral.getElementById("imageItem"+id+"Edit").onClick = function() {editUserEvent(userEventID)};
    frameInfoAndGeneral.getElementById("item"+id+"Title").data = userData[userEventID].name;
    frameInfoAndGeneral.getElementById("item"+id+"Line1").data = getMonthName(userData[userEventID].date.getMonth()) +
            " " + userData[userEventID].date.getDate() + ", " + userData[userEventID].date.getFullYear();
    if (userData[userEventID].allDay) {
        frameInfoAndGeneral.getElementById("item"+id+"Line2").data = loc("event.allDay");
    } else {
        var hours = userData[userEventID].date.getHours();
        var prefix = loc("ampm.am");
        if (isFrenchLocale()) {
            frameInfoAndGeneral.getElementById("item" + id + "Line2").data = hours + " h " + formatMinutes(userData[userEventID].date.getMinutes());
        } else {
            if (hours >= 12) {
                hours = hours - 12;
                prefix = loc("ampm.pm");
            }
            frameInfoAndGeneral.getElementById("item" + id + "Line2").data = hours + ":" + formatMinutes(userData[userEventID].date.getMinutes()) + " " + prefix;
        }
    }
}

function editUserEvent(userEventID) {
    hideMainPromo();
    displayEventData(userEventID);
    displayEventLabels();
    displayFrame(ADD_FRAME);
}

/////////////////////////////////////////////////
// Display add button and message
/////////////////////////////////////////////////
function displayAddEvent() {

}


function scrollDown() {
    hideMainPromo();
    startY = system.event.vOffset;
}

function scrollUp() {
}

function hideMainPromo() {
    if (showMainPromo) {
        showMainPromo = false;
        updatePromo();
    }
}

function scrollDrag() {
    var numberOfItems = getNumberOfItemsToDisplay() - 2;    // If we have more than 3 items, we always want to see 3 items (without placeholders)
    if (numberOfItems <=1)      // Up to 3 items we don't need scrolling
        return;

    var stepY = Math.floor((BOTTOM_SCROLLER_POSITION - TOP_SCROLLER_POSITION) / numberOfItems);
    var delta = system.event.vOffset - startY;
    if (delta >= stepY && imageScroller.vOffset <= BOTTOM_SCROLLER_POSITION && currentOffset < (numberOfItems - 1)) {
        displayItems(++currentOffset);
        startY += stepY;
        delta -= stepY;
    } else if (delta <= -1 * stepY && imageScroller.vOffset >= TOP_SCROLLER_POSITION && currentOffset > 0 ) {
        displayItems(--currentOffset);
        startY -= stepY;
        delta += stepY;
    }

    var currentPos = delta + (currentOffset * stepY) + SCROLLER_OFFSET;
    if (currentPos < TOP_SCROLLER_POSITION) {
        imageScroller.vOffset = TOP_SCROLLER_POSITION;
    } else if (currentPos > BOTTOM_SCROLLER_POSITION) {
        imageScroller.vOffset = BOTTOM_SCROLLER_POSITION;
    } else {
        imageScroller.vOffset = currentPos;
    }
}

/////////////////////////////////////////////////
// Count number of general + user events to display
/////////////////////////////////////////////////
function getNumberOfItemsToDisplay() {
    var numbers = currentHolidays.length;
    numbers += getNumberOfUserEvent();
    return numbers;
}

function getNumberOfUserEvent() {
    var numbers = 0;
    for (var i=0; i < userData.length; i++) {
        if (userData[i] != null)
            numbers++;
    }
    return numbers;
}

function showMainScreenPromo(show) {
    summerTitle.visible = show;
    summerText.visible = show;
    imageSummer.visible = show;
}

function showItem(show, id, general) {
    frameInfoAndGeneral.getElementById("imageItem"+id+"Close").visible = show;
    frameInfoAndGeneral.getElementById("imageItem"+id+"Edit").visible = show && !general;
    var title = frameInfoAndGeneral.getElementById("item"+id+"Title");
    title.visible = show;
    var line1 = frameInfoAndGeneral.getElementById("item"+id+"Line1");
    line1.visible = show;
    var color = USER_LINE1_COLOR;
    if (general)
        color = GENERAL_LINE1_COLOR;
    line1.color = color;
    line1.vOffset = title.vOffset + title.height + 5;
    var line2 = frameInfoAndGeneral.getElementById("item"+id+"Line2");
    line2.vOffset = line1.vOffset + line1.height + 15;
    line2.visible = show && !general;
    if (id != 3)
        frameInfoAndGeneral.getElementById("imageItem"+id+"Div").visible = show;
}

function showAdd(show, id) {
    frameInfoAndGeneral.getElementById("imageAdd"+id).visible = show;
    frameInfoAndGeneral.getElementById("add"+id+"Title").visible = show;
    frameInfoAndGeneral.getElementById("add"+id+"Title").data = loc("click.button.add");
    if (id != 3)
        frameInfoAndGeneral.getElementById("imageAdd"+id+"Div").visible = show;
}

function keepEvent() {
    displayFrame(NO_FRAME);
}

function checkReminders() {
    compileArrayOfReminders();
    filterReminders();
    displayReminders();
}

/////////////////////////////////////////////////
// Filter reminder that should be displayed
/////////////////////////////////////////////////
function filterReminders() {
    var nowTime = new Date();
    reminderToDisplay.remove(reminderToDisplay, 0, reminderToDisplay.length -1);
    for (var i = 0; i < reminderData.length; i++) {
        var reminder = reminderData[i];
        if (reminder.remindDate < nowTime) {
            reminderToDisplay[reminderToDisplay.length] = i;
        }
    }
}

/////////////////////////////////////////////////
// Filter reminder that should be displayed
/////////////////////////////////////////////////
function displayReminders() {
    if (reminderToDisplay.length != 0) {
        openReminderFrame();
        currentReminder = 0;
        displayReminder(currentReminder);
    }
}

function displayReminderData() {
    var reminder = reminderData[reminderToDisplay[currentReminder]];
    var line1Text = "";
    var date;
    var line2Text = "";
    if (reminder.general) {
        var genEvent = generalData[reminder.eventId];
        line1Text = genEvent.title;
        date = genEvent.date;
    } else {
        var userEvent = userData[reminder.eventId];
        line1Text = userEvent.name;
        date = userEvent.date;
    }
    var now = new Date();
    if (now.getFullYear() == date.getFullYear() && now.getMonth() == date.getMonth() && now.getDate() == date.getDate()) {
        line2Text += loc("remind.today");
    } else {
        line2Text = getMonthName(date.getMonth()) + " " + date.getDate() + ", " + date.getFullYear();    
    }
    if (reminder.general || (!reminder.general && userData[reminder.eventId].allDay)) {
        line2Text += " " + loc("event.allDay") + " ";
    }
    else {
        line2Text += loc("remind.at");
        var hours = date.getHours();
        var prefix = loc("ampm.am");
        if (isFrenchLocale()) {
            line2Text += hours + " h " + formatMinutes(date.getMinutes());
        } else {
            if (hours>=12) {
                hours = hours - 12;
                prefix = loc("ampm.pm");
            }
            line2Text += hours + ":" + formatMinutes(date.getMinutes()) + " " + prefix;
        }
    }
    remindLine1.data = line1Text;
    remindLine2.data = line2Text;
    remindLine2.vOffset = remindLine1.vOffset + remindLine1.height + 15;

    // Play music assigned for reminder
    if (!reminder.general && userData[reminder.eventId].audio) {
        playMusic(userData[reminder.eventId].sound);
    }
}

function playMusic(sound) {
    if (sound == loc("sound.Summer")) {
        play('Resources/sound/summer.mp3');
    } else if (sound == loc("sound.Autumn")) {
        play('Resources/sound/fall.mp3');
    } else if (sound == loc("sound.Winter")) {
        play('Resources/sound/winter.mp3');
    } else if (sound == loc("sound.Spring")) {
        play('Resources/sound/spring.mp3');
    } else {
        // Wrong sound, nothing to play
    }
}

function displayReminder(delta) {
    if (currentReminder + delta == reminderToDisplay.length)
        currentReminder = 0;
    else if (currentReminder + delta == -1)
        currentReminder = reminderToDisplay.length - 1;
    else
        currentReminder = currentReminder + delta;
    displayReminderData();
}

function showPrevReminder() {
    imagePrevReminderOff.visible = false;
    imagePrevReminder.visible = true;
}

function hidePrevReminder() {
    imagePrevReminderOff.visible = true;
    imagePrevReminder.visible = false;
}

function showNextReminder() {
    imageNextReminderOff.visible = false;
    imageNextReminder.visible = true;
}

function hideNextReminder() {
    imageNextReminderOff.visible = true;
    imageNextReminder.visible = false;
}

function displayReminderButtons() {
    var displayReminderButtons = false;
    if (reminderToDisplay.length > 1) {
        displayReminderButtons = true;
    }

    if (displayReminderButtons) {
        showPrevReminder();
        showNextReminder();
    } else {
        hidePrevReminder();
        hideNextReminder();
    }
}

function displayFrame(frameId) {
    frameAddEvent.visible = (frameId == ADD_FRAME);
    frameReminder.visible = (frameId == REMINDER_FRAME);
    frameDeleteEvent.visible = (frameId == DELETE_FRAME);
    frameErrorMessage.visible = (frameId == ERROR_FRAME);
    reminderTimer.ticking = (frameId == NO_FRAME) || (frameId == REMINDER_FRAME);
}

function checkEventNameLength(event) {
    if (eventName.data.length > MAX_EVENT_NAME_LEN)
        eventName.data = eventName.data.substring(0, MAX_EVENT_NAME_LEN);
}

function checkEventReminderLength(event) {
    if (eventRemindMe.data.length > MAX_EVENT_REMINDER_LEN)
        eventRemindMe.data = eventRemindMe.data.substring(0, MAX_EVENT_REMINDER_LEN);
}

function openPromotionURL() {
    openURL(loc("promo.url"));
}

function openPromoURL() {
    openURL(loc("promo.url."+currentPromo));
}